#include <bits/stdc++.h>
using namespace std;
const int TLIMIT = 100000;
const int NLIMIT = 100000;
const int MLIMIT = 100000;
const int QLIMIT = 100000;
const int WLIMIT = 2000000;
int NSUM = 0;
int MSUM = 0;
int QSUM = 0;

int ans[QLIMIT + 5];
int cnt_div[WLIMIT + 5];
long long deg[NLIMIT + 5];
int get_pw2_div(long long x){
    if(x == 0){
        return 0;
    }
    int ret = 0;
    while(!(x & 1)){
        ret++;
        x >>= 1;
    }
    return ret;
}
struct Edge{
    int u,v,w;
};
struct event{
    Edge edge;
    int l,r;
};

vector<Edge> updates[4 * QLIMIT + 30];
void add_event(int v,int tl,int tr,int l,int r, Edge edge){
    if(tr < l || r < tl)
        return;
    if(l <= tl && tr <= r){
        updates[v].push_back(edge);
        return;
    }
    int tm = (tl + tr)/2;
    add_event(v*2, tl, tm, l, r, edge);
    add_event(v*2 + 1, tm + 1, tr, l, r, edge);
}

struct diff{
    int a,b;
    int sza,para;
};
int sz[NLIMIT + 5], par[NLIMIT + 5];
vector<diff> rollback;
int find(int a){
    if(a == par[a])
        return a;
    return find(par[a]);
}
void merge(int a,int b){
    a = find(a);
    b = find(b);
    if(a == b)
        return;
    if(sz[a] > sz[b])
        swap(a,b);
    rollback.push_back({a,b,sz[a],par[a]});
    sz[b] += sz[a];
    par[a] = b;
}
void do_rollback(){
    assert(rollback.size());
    diff tmp = rollback.back();
    rollback.pop_back();
    sz[tmp.b] -= tmp.sza;
    par[tmp.a] = tmp.para;
}
int cnt = 0;
int pw2_cnt[100];
void change(int a,int b){
    if(deg[a]){
        pw2_cnt[get_pw2_div(deg[a])]--;
        cnt--;
    }
    deg[a] += b;
    if(deg[a]){
        pw2_cnt[get_pw2_div(deg[a])]++;
        cnt++;
    }
}
void calculate(int v,int tl,int tr,int gcd,int x){
    int tmp = rollback.size();
    for(auto u:updates[v]){
        if(x == 0)
            x = u.u;
        change(u.u, u.w);
        change(u.v, u.w);
        merge(u.u, u.v);
        gcd = __gcd(gcd, u.w);
    }
    if(tl == tr){
        if(x == 0){
            //no edge
            ans[tl] = -1;
        }
        else if(cnt != sz[find(x)]){
            //not connected
            ans[tl] = 0;
        }
        else{
            //connected
            int cur_odd = pw2_cnt[get_pw2_div(gcd)];
            if(cur_odd == 0 || cur_odd == 2){
                ans[tl] = cnt_div[gcd];
            }
            else{
                if(gcd & 1){
                    ans[tl] = 0;
                }
                else{
                    ans[tl] = cnt_div[gcd / 2];
                }
            }
        }
        for(auto u:updates[v]){
            change(u.u, -u.w);
            change(u.v, -u.w);
        }
        while(rollback.size() > tmp){
            do_rollback();
        }
        return;
    }
    int tm = (tl + tr)/2;
    calculate(v * 2, tl, tm, gcd, x);
    calculate(v * 2 + 1, tm + 1, tr, gcd, x);
    for(auto u:updates[v]){
        change(u.u, -u.w);
        change(u.v, -u.w);
    }
    while(rollback.size() > tmp){
        do_rollback();
    }
}

void solve(){
    int n,m,q;
    cin >> n >> m >> q;
    assert(1 <= n && n <= NLIMIT);
    assert(1 <= m && m <= MLIMIT);
    assert(1 <= q && q <= QLIMIT);
    NSUM += n;
    MSUM += m;
    QSUM += q;
    vector<event> events;
    map<array<int,3>,vector<int>> mp;
    for(int i = 1;i <= m;i++){
        int a,b,c;
        cin >> a >> b >> c;
        assert(1 <= a && a <= n);
        assert(1 <= b && b <= n);
        assert(1 <= c && c <= WLIMIT);
        if(a > b)
            swap(a,b);
        mp[{a,b,c}].push_back(0);
    }
    for(int i = 1; i <= q; i++){
        char type;
        int u,v,w;
        cin >> type >> u >> v >> w;
        assert(1 <= u && u <= n);
        assert(1 <= v && v <= n);
        assert(1 <= w && w <= WLIMIT);
        if(u > v)
            swap(u,v);
        if(type == '+'){
            mp[{u,v,w}].push_back(i);               
        }
        else if(type == '-'){
            int sz = mp[{u,v,w}].size(); 
            assert(sz);
            events.push_back({{u,v,w}, mp[{u,v,w}].back(),i-1});
            mp[{u,v,w}].pop_back();
        }
        else{
            assert(0);
        }
    }
    for(auto u:mp){
        for(auto c:u.second){
            events.push_back({{u.first[0] ,u.first[1], u.first[2]},c,q});
        }
    }

    for(auto u:events){
        // cout << '[' <<  u.l << ", " << u.r << "]: " << u.edge.u << ' ' << u.edge.v << ' ' << u.edge.w << endl;
        add_event(1,0,q,u.l,u.r,u.edge);
    }

    for(int i = 1;i <= n; i++){
        sz[i] = 1;
        par[i] = i;
    }
    calculate(1, 0, q, 0, 0);
    for(int i = 1;i <= 4 * q + 5; i++){
        updates[i].clear();
    }
    for(int i = 1; i <= q; i++){
        cout << ans[i];
        if(i != q){
            cout << '\n';
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for(int i = 1;i<=WLIMIT;i++){
        for(int j = i; j <= WLIMIT;j += i){
            cnt_div[j] += 1;
        }
    }
    int t;
    cin >> t;
    assert(1 <= t && t <= TLIMIT);
    while(t--){
        solve();
        if(t){
            cout << '\n';
        }
    }
    assert(NSUM <= 100000);
    assert(MSUM <= 100000);
    assert(QSUM <= 100000);
}