#include "sayilar_diyari_cpp.h"

#include <bits/stdc++.h>

using namespace std;

const int K = 3e7, INF = 1e9;

vector<int> sieve(K + 1, 0), primes, leafcnt;

vector<vector<pair<int, int>>> binlift;

void do_sieve(){
	for(int i = 2; i * i <= K; i++){
		if(sieve[i] == 0){
			for(int j = i * i; j <= K; j += i){
				if(sieve[j] == 0){
					sieve[j] = i;
				}
			}
		}
	}

	for(int i = 2; i <= K; i++) if(sieve[i] == 0) sieve[i] = i;
}

int calc_divsum(int x){
	int ans, cur, curpow, cursum;

	ans = cur = curpow = cursum = 1;

	while(x != 1){
		if(sieve[x] != cur){
			ans *= cursum;

			cur = curpow = sieve[x], cursum = sieve[x] + 1;
		}
		else curpow *= cur, cursum += curpow;

		x /= sieve[x];
	}

	ans *= cursum;

	return ans;
}

struct Edge{
	int a, b, c;

	bool operator < (const Edge &sc) const{
		return c < sc.c;
	}
};

struct DSU{
	vector<int> par, root, setsize;

	DSU(int n){
		par = root = setsize = vector<int>(n, 0);
		
		for(int i = 0; i < n; i++){
			par[i] = root[i] = i;
			setsize[i] = 1;
		}
	}

	int setfind(int a){
		if(a == par[a]) return a;
		else return par[a] = setfind(par[a]);
	}

	void setunion(int a, int b){
		a = setfind(a), b = setfind(b);

		if(a != b){
			if(setsize[b] > setsize[a]) swap(a, b);

			par[b] = par[a];
			setsize[a] += setsize[b];
			root[a] = max(root[a], root[b]);
		}
	}
};

void baslangic(int N, int M, vector<int> A, vector<int> B, vector<int> C){
	do_sieve();

	vector<Edge> edges;

	edges.assign(M, {});

	for(int i = 0; i < M; i++) edges[i] = {A[i], B[i], calc_divsum(C[i])};

	sort(edges.begin(), edges.end());

	DSU dsu(2 * N - 1);
	binlift.assign(__lg(2 * N - 1), vector<pair<int, int>>(2 * N - 1, pair<int, int>{-1, INF}));
	leafcnt.assign(2 * N - 1, 1);

	int nodecnt = N;

	for(auto edge : edges){
		int a = dsu.root[dsu.setfind(edge.a)], b = dsu.root[dsu.setfind(edge.b)];

		if(a != b){
			binlift[0][a] = binlift[0][b] = {nodecnt, edge.c};

			leafcnt[nodecnt] = leafcnt[a] + leafcnt[b];

			dsu.setunion(a, nodecnt);
			dsu.setunion(b, nodecnt);

			nodecnt++;
		}
	}

	for(int i = 1; i < binlift.size(); i++){
		for(int v = 0; v < nodecnt; v++){
			int p = binlift[i - 1][v].first;

			if(p != -1) binlift[i][v] = binlift[i - 1][p];
		}
	}
}

int sorgu(int V, int K){
	int divsum = calc_divsum(K);

	for(int i = binlift.size() - 1; i >= 0; i--){
		if(binlift[i][V].second < divsum) V = binlift[i][V].first;
	}

	return leafcnt[V];
}
